#include "adc.h"

	extern uint8_t loop;
	extern uint8_t finish;
	extern uint8_t modus;
	extern uint8_t freq;

	ISR(ANA_COMP_vect)
	{
	}

	ISR(ADC_vect)
	{
	if(modus==0)
		{
		loop = ADCH;
		} else{
		freq= ADCH;
		}
	finish =1;
	}

void adc_init_adc()
	{
	
	/*************************************/
	/* Analog/Digital Converter Register */
	/*************************************/
	
	// ADMUX = 0bx000.0000; #7 xx
	// ADMUX = 0b0x00.0000; #6 REFS0 Voltage Reference Selection
	// ADMUX = 0b00x0.0000; #5 ADLAR ADC Left Adjust Result
	// ADMUX = 0b000x.0000; #4 xx
	// ADMUX = 0b0000.x000; #3 xx
	// ADMUX = 0b0000.0x00; #2 xx
	// ADMUX = 0b0000.00x0; #1 MUX1 Analog Channel Selection Bits
	// ADMUX = 0b0000.000x; #0 MUX0 Analog Channel Selection Bits

	ADMUX &=~ (1 << REFS0); // VCC als VREF
	ADMUX |=  (1 << ADLAR); // Ergebnis Linksbndig, da nur 8 bit ntig
	ADMUX |=  (1 << MUX1);  // PB4 als AD Eingang whlen
	ADMUX &=~ (1 << MUX0);  // PB4 als AD Eingang whlen

	//ADCSRA = 0bx000.0000; #7 ADEN ADC Enable
	//ADCSRA = 0b0x00.0000; #6 ADSC ADC Start Conversion
	//ADCSRA = 0b00x0.0000; #5 ADATE ADC Auto Trigger Enable
	//ADCSRA = 0b000x.0000; #4 ADIF ADC Interrupt Flag
	//ADCSRA = 0b0000.x000; #3 ADIE Interrupt Enable
	//ADCSRA = 0b0000.0x00; #2 ADPS2 ADC Prescaler Select
	//ADCSRA = 0b0000.00x0; #1 ADPS1 ADC Prescaler Select
	//ADCSRA = 0b0000.000x; #0 ADPS0 ADC Prescaler Select

	ADCSRA &=~ ( 1 << ADEN);
	ADCSRA &=~ ( 1 << ADSC);
	ADCSRA &=~ ( 1 << ADATE); // kein Auto Trigger
	ADCSRA |=  ( 1 << ADIE);   // IRQ nach Conversion aufrufen
	ADCSRA |=  ( 1 << ADPS2); // Prescaler auf 8 setzen fr 0.6MHz uC
	ADCSRA |=  ( 1 << ADPS1); // Prescaler auf 8 setzen fr 0.6MHz uC
	ADCSRA |=  ( 1 << ADPS0); // Prescaler auf 8 setzen fr 0.6MHz uC

	//ADCSRB = 0bx000.0000; #7 xx
	//ADCSRB = 0b0x00.0000; #6 ACME ADC Auto Trigger Source
	//ADCSRB = 0b00x0.0000; #5 xx
	//ADCSRB = 0b000x.0000; #4 xx
	//ADCSRB = 0b0000.x000; #3 xx
	//ADCSRB = 0b0000.0x00; #2 ADTS2
	//ADCSRB = 0b0000.00x0; #1 ADTS1
	//ADCSRB = 0b0000.000x; #0 ADTS0
	
	/* Auto Trigger disabled !
	ADCSRB &=~ ( 1 << ADTS2);
	ADCSRB &=~ ( 1 << ADTS1);
	ADCSRB &=~ ( 1 << ADTS0);
	*/

	// DIDR0 = 0bx000.0000; #7 xx
	// DIDR0 = 0b0x00.0000; #6 xx
	// DIDR0 = 0b00x0.0000; #5 ADC0D (PB5)
	// DIDR0 = 0b000x.0000; #4 ADC2D (PB4)
	// DIDR0 = 0b0000.x000; #3 ADC3D (PB3)
	// DIDR0 = 0b0000.0x00; #2 ADC1D (PB2)
	// DIDR0 = 0b0000.00x0; #1 AIN1D
	// DIDR0 = 0b0000.000x; #0 AIN0D

	DIDR0 |= ( 1 << ADC0D);
	DIDR0 &=~ ( 1 << ADC2D); // PB4 als Eingang aktivieren
	DIDR0 |= ( 1 << ADC3D);
	DIDR0 |= ( 1 << ADC1D);
	// fr Analog Comparator !
	DIDR0 |= ( 1 << AIN1D);
	DIDR0 |= ( 1 << AIN0D);


	// ADCW ADC 16 bit Data Register
	// ADCH ADC  8 bit Data Register High Byte
	// ADCL ADC  8 bit Data Register Low  Byte
	}

void adc_init_ac()
	{
	/*************************************/
	/* Analog Comparator Register */
	/*************************************/
	
	// ACSR = 0b0000.0000; #7 ACD Analog Comparator disable
	// ACSR = 0b0000.0000; #6 ACBG Analog Comparator Bandgap
	// ACSR = 0b0000.0000; #5 ACO Analog Comparator Output
	// ACSR = 0b0000.0000; #4 ACI Analog Comparator Interrupt Flag
	// ACSR = 0b0000.0000; #3 ACIE Analog Comparator Interrupt Enable
	// ACSR = 0b0000.0000; #2 xx
	// ACSR = 0b0000.0000; #1 ACIS1 Analog Comparator Interrupt Mode
	// ACSR = 0b0000.0000; #0 ACIS0 Analog Comparator Interrupt Mode

	ACSR &=~ (1 << ACD);
	ACSR &=~ (1 << ACBG);
	ACSR &=~ (1 << ACIE);
	ACSR &=~ (1 << ACIS1);
	ACSR &=~ (1 << ACIS0);
	}

void adc_conv_on()
	{
	ADCSRA |=  (1 << ADEN);
	}

void adc_conv_off()
	{
	ADCSRA &=~ (1 << ADEN);
	}

void adc_conv_start()
	{
	finish =0;
	ADCSRA |= (1<<ADSC);
	}

void adc_conv_in(uint8_t i)
	{
	switch(i){
		case 0: { // ADC0 / PB5
			ADMUX &=~ (1 << MUX1); 
			ADMUX &=~ (1 << MUX0);
			break;
			}
		case 1: { // ADC1 / PB2
			ADMUX &=~ (1 << MUX1); 
			ADMUX |=  (1 << MUX0);
			break;
			}
		case 2: { // ADC2 / PB4
			ADMUX |=  (1 << MUX1); 
			ADMUX &=~ (1 << MUX0);
			break;
			}
		case 3: { // ADC3 / PB3
			ADMUX |=  (1 << MUX1); 
			ADMUX |=  (1 << MUX0);
			break;
			}
		default :{// ADC2 / PB4
			ADMUX |=  (1 << MUX1); 
			ADMUX &=~ (1 << MUX0);
			}
		}
	}

void adc_comp_on()
	{
	ACSR |= (1 << ACD);
	}

void adc_comp_off()
	{
	ACSR &=~ (1 << ACD);
	}


